/*********************************************************************
*                                                                    *          
*                              FLY                                   *
*                           --E#Y#E--	    			     *
*                         ===MUSCLE===                               *
*                                                                    *
*********************************************************************/
/* Header Files */
#include "opengl.h"
 
#define UNI

/* Speed */
#define sRoll		0.40f
#define sPitch		0.20f
#define sYaw		0.20f
#define sPlaneX		0.04f
#define sPlaneY		0.02f
#define sPlaneZ		0.04f

/* Plane */
GLfloat roll; 
GLfloat pitch;
GLfloat yaw;
GLfloat xPlane;
GLfloat yPlane;
GLfloat zPlane;	

char Fday = FALSE;
char Fnight = FALSE;
char Fblack = TRUE;
char Fgrid = TRUE;
char Ftexture = FALSE;
char Fcloud = FALSE;

/* Texture */
GLubyte *bla;
GLubyte *des;
GLubyte *sea;
GLubyte *sky;

/* Matrix */
float projection[ID];
float modelview[ID];

/*---------------------------------------------------------------------------*/ 

float circle[ID] = { 
		
1.0, 0.0, 0.0, 0.0, 
0.0, 1.0, 0.0, 0.0, 
0.0, 0.0, 1.0, 0.0, 
0.0, 0.0, 0.0, 1.0 };


unsigned int weg[27][27] = {
	
/*A B C D E F G H I J K L M N O P Q R S T U V W X Y*/
 {0,1,1,0,0,0,1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0, 0},
 {1,0,1,1,0,0,1,1,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0, 0},
 {1,1,0,1,1,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0, 0},
 {0,1,1,0,1,1,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0, 0},
 {0,0,1,1,0,1,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0, 0},
 {0,0,0,1,1,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0, 0},
 {1,1,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0, 0},
 {0,1,0,0,0,0,1,0,1,1,1,0,0,1,0,0,0,0,0,0,0,0,0,0,0, 0},
 {0,0,0,0,0,0,1,1,0,1,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0, 0},
 {0,0,0,0,0,0,0,1,1,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0, 0},
 {0,1,0,1,0,0,0,1,0,0,0,1,0,1,0,0,0,0,0,0,0,0,0,0,0, 0},
 {0,0,0,1,0,1,0,0,0,0,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0, 0},
 {0,0,0,0,0,1,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0, 0},
 {0,0,0,0,0,0,0,1,0,1,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0, 0},
 {0,0,0,0,0,0,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0, 0},
 {1,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,1,0,1,0,1,0,0,0,0, 0},
 {0,0,1,0,1,0,0,0,0,0,0,0,0,0,0,1,0,1,0,0,1,1,0,0,0, 0},
 {0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,1,1,0,0, 0},
 {0,0,0,0,0,0,1,0,1,0,0,0,0,0,0,1,0,0,0,1,1,0,0,1,0, 0},
 {0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,1,0,0,0,0,1,1, 0},
 {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,1,0,0,1,0,1,0, 0},
 {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,1,0,1,0,0, 0},
 {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,0,0,0, 0},
 {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,1, 0},
 {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,0, 0}};
/*A B C D E F G H I J K L M N O P Q R S T U V W X Y*/


/*---------------------------------------------------------------------------*/

/* Load Texture */
void loadTexture()
{
	/* Load Texture */
	char *forestTex;
	char *desertTex;
	char *seaoceTex;
	char *cloudTex;
	
	/* Textures */
	forestTex = "PIXEL/forest.png";
	desertTex = "PIXEL/desert.png";
	seaoceTex = "PIXEL/sea.png";
	cloudTex = "PIXEL/cloud.png";
	
	/* Read PNG */
	read_png(forestTex, &bla);		
	read_png(desertTex, &des);
	read_png(seaoceTex, &sea);
	read_png(cloudTex, &sky);
}

/*---------------------------------------------------------------------------*/

/* Load Config */
void loadConfig(char code, float config)
{
	/* Config */
	FILE *configFile;
	configFile=fopen("DATA/config.fs","r");
	while(fscanf(configFile,"%s %f", &code, &config)!= EOF)
	{ 
		code = config;
	}
	fclose(configFile);
}

/*---------------------------------------------------------------------------*/ 

/* Init Grid */
void initGrid()
{	
	/* Background Color */
	glEnable(GL_BLEND);
	glEnable(GL_AMBIENT);
	glEnable(GL_LIGHT7);
	glEnable(GL_LIGHTING);	
	glEnable(GL_DEPTH_TEST);
	glEnable(GL_COLOR_MATERIAL);
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	
	/* Night */
	if(Fnight)
	{	
		glClearColor( 0.10f , 0.20f , 0.30f , 0.5f );
		glDisable(GL_LIGHT7);	
	}
	
	/* Day */
	if(Fday)
	{	
		glClearColor( 0.30f , 0.50f , 0.70f , 0.5f );
		glDisable(GL_LIGHTING);
	}
	
	/* Grid */
	if(Fblack)
	{	
		glClearColor( 0.01f , 0.01f , 0.01f , 0.5f );
		glDisable(GL_LIGHTING);
	}
}

/*---------------------------------------------------------------------------*/


/* Shader Language */
void textureShader(GLuint shader)
{	
	#ifdef UNI	
	/* Texture Shader */
	CreateShader();
	CreateProgram(shader);
	
	/* Init */
	Location(shader,0,"a_Vertex");
	Location(shader,1,"a_Color");
	Location(shader,2,"a_TexCoord");

	/* Array */
	glEnableVertexAttribArray(0); 
    	glEnableVertexAttribArray(1); 
	glEnableVertexAttribArray(2);

	/* Passing Data */
	glGetFloatv(GL_PROJECTION_MATRIX, projection);
	glGetFloatv(GL_MODELVIEW_MATRIX, modelview);
	
	/* Matrix */
	Uniform4x4(shader,"projection_matrix", 0, projection);
	Uniform4x4(shader,"modelview_matrix", 1, modelview);
	Uniform(shader,"texture0", 0);
	DeleteShader(shader);
	#endif
}

/*---------------------------------------------------------------------------*/

/* PlaneView */
void PlaneView(GLfloat xPlane, GLfloat yPlane, GLfloat zPlane,	
		GLfloat roll, GLfloat pitch, GLfloat yaw)
{	
	/* Rotation */
	glRotatef(-roll,  0.0f, 0.0f, 1.0f);
	glRotatef(-yaw,   0.0f, 1.0f, 0.0f);
	glRotatef(-pitch, 1.0f, 0.0f, 0.0f);

	/* Translate */
	glTranslatef(-xPlane, -yPlane, -zPlane);
	
	/* Multiplying Matrices */
	/*glLoadMatrix(matrix[ID]);*/
	/*glMultMatrix(matrix[ID]);*/
				 
}

/*---------------------------------------------------------------------------*/

/* Render Grid */
void GridRender(char *name)
{
	/* Load File */
	char code;
	FILE *grid;
	grid=fopen(name,"r");

        /* Grid File */
	while(fscanf(grid,"%s %f %f %f", &code, &gl.tri.x, &gl.tri.y, &gl.tri.z)!= EOF)
	{ 
		glVertex3f(gl.tri.x, gl.tri.y, gl.tri.z);
	}
	fclose(grid);
}

/*---------------------------------------------------------------------------*/

/* Render Landscape */
void SubImage1(char *name, GLubyte *pixel)
{
	/* Load File */
	char code;
	FILE *land;
	land=fopen(name,"r");
        
        /* Image Data */
        glTexImage2D(GL_TEXTURE_2D,0,GL_RGBA,128,128,0,GL_BGRA,GL_UNSIGNED_BYTE,pixel);
	glTexSubImage2D(GL_TEXTURE_2D,0,0,0,128,128,GL_BGRA,GL_UNSIGNED_BYTE,pixel);	
	glTexSubImage2D(GL_TEXTURE_2D,0,2,0,128,128,GL_BGRA,GL_UNSIGNED_BYTE,pixel);
	glTexSubImage2D(GL_TEXTURE_2D,0,0,2,128,128,GL_BGRA,GL_UNSIGNED_BYTE,pixel);
	glTexSubImage2D(GL_TEXTURE_2D,0,2,2,128,128,GL_BGRA,GL_UNSIGNED_BYTE,pixel);

	/* Forest Triangles */
	glBegin(GL_TRIANGLES);
	while(fscanf(land,"%s %f %f %f %f %f", &code, &gl.tex.s, &gl.tex.t, 
		&gl.tri.x, &gl.tri.y, &gl.tri.z) != EOF)
	{ 	
		glTexCoord2f(gl.tex.s, gl.tex.t);
		glVertex3f(gl.tri.x, gl.tri.y, gl.tri.z);
	}
	glEnd();
	fclose(land);
}

/*---------------------------------------------------------------------------*/

/* Render Landscape */
void SubImage2(GLubyte *pixel)
{
	/* Image Data */
	glTexImage2D(GL_TEXTURE_2D,0,GL_RGBA,128,128,0,GL_BGRA,GL_UNSIGNED_BYTE,pixel);
	
	/* Clouds */
	glBegin(GL_QUADS);
	glTexCoord2f(0.0,0.0);glVertex3f( 20.0f,4.0f, 20.0f);
	glTexCoord2f(2.0,0.0);glVertex3f( 20.0f,4.0f,-20.0f);
	glTexCoord2f(2.0,2.0);glVertex3f(-20.0f,4.0f,-20.0f);
	glTexCoord2f(0.0,2.0);glVertex3f(-20.0f,4.0f, 20.0f);
	glEnd();
}

/*---------------------------------------------------------------------------*/

/* Render Landscape */
void Landscape()
{	
	/* Grid */
	/*char *gridFileA;*/
	char *gridFileB;

	/* Landscape */
	char *forestFile;
	char *desertFile;
	char *seaoceFile;
	
	/* Render Triangles */
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	CameraLook();
	PlaneView(xPlane, yPlane, zPlane, roll, pitch, yaw);
	glLineWidth(1);
	glPointSize(5);
	
	if(Fgrid)
	{
	        /* Grid File */
	        /*gridFileA = "DATA/gridA.fs";*/
	        gridFileB = "DATA/gridB.fs";
	        
	        /* Grid Render */
	        glPolygonMode(GL_FRONT_AND_BACK, GL_LINE);
	        glBegin(GL_POINTS);
	        glColor4f(0.0f, 0.9f, 0.9f, 1.0f);	
                GridRender(gridFileB);
	        glEnd();
	        
	        /* Grid Render */	
	        glPolygonMode(GL_FRONT_AND_BACK, GL_LINE);
	        glBegin(GL_TRIANGLES);
	        glColor4f(0.7f, 0.7f, 0.7f, 1.0f);	
	        GridRender(gridFileB);
	        glEnd();
	}

	/* Filtering Mode */
	/*glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);*/
	/*glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);*/
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_MIRRORED_REPEAT);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_MIRRORED_REPEAT);
	/*glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);*/
	/*glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);*/
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
	
	/* Texture */
	if(Ftexture)
	{
	        /* Landscape File */
	        forestFile = "DATA/forest.fs";
	        desertFile = "DATA/desert.fs";
	        seaoceFile = "DATA/seaoce.fs";
	        
	        /* Enable Texture */
	        glEnable(GL_TEXTURE_2D);
	        SubImage1(forestFile, bla);
	        SubImage1(desertFile, des);
	        SubImage1(seaoceFile, sea);
	}
	
	/* Cloud */
	if(Fcloud)
	{
		SubImage2(sky);
	}
	
	/* Disable Texture */
	glDisable(GL_COLOR_MATERIAL);	
	glDisable(GL_TEXTURE_2D);
	glDisable(GL_LIGHTING);
	glDisable(GL_AMBIENT);
}

/*-------------------------------------------------------------------------*/

/* Process Event */
void process_event1(XEvent report)
{   
	KeySym key;
	key = XLookupKeysym (&report.xkey, 0);
	
	/* Keyboard Control Keys */	
	switch(key)
	{		
		case XK_Left: 
		roll += sRoll; 
		break;

		case XK_Right: 
		roll -= sRoll; 
		break;
		
		case XK_Up: 
		pitch += sPitch; 
		break;

		case XK_Down: 
		pitch -= sPitch; 
		break;

		case XK_e: 
		yaw += sYaw; 
		break;

		case XK_q: 
		yaw -= sYaw; 
		break;

		case XK_a: 
		xPlane -= sPlaneX; 
		break;
		
		case XK_d: 
		xPlane += sPlaneX; 
		break;

		case XK_w: 
		yPlane += sPlaneY; 
		break;

		case XK_s: 
		yPlane -= sPlaneY; 
		break;

		case XK_b: 
		zPlane += sPlaneZ; 
		break;

		case XK_space: 
		zPlane -= sPlaneZ; 
		break;
		
		case XK_F5: 
		Fday = FALSE;
		Fnight= FALSE;
		Fblack = TRUE;
		Fgrid = TRUE;
		Ftexture = FALSE;
		Fcloud = FALSE;
		break;
		
		case XK_F6: 
		Fday = TRUE;
		Fnight= FALSE;
		Fblack = FALSE;
		Fgrid = FALSE;
		Ftexture = TRUE;
		Fcloud = FALSE;
		break;
		
		case XK_F7: 
		Fday = TRUE;
		Fnight= FALSE;
		Fblack = FALSE;
		Fgrid = FALSE;
		Ftexture = TRUE;
		Fcloud = TRUE;
		break;
		
		case XK_F8: 
		Fday = FALSE;
		Fnight = TRUE;
		Fblack = FALSE;
		Fgrid = FALSE;
		Ftexture = TRUE;
		Fcloud = FALSE;
		break;

		case XK_Escape: 
		closeWin(); 
		break;
	}
}

/*---------------------------------------------------------------------------*/


