/*********************************************************************
*                                                                    *          
*                              FLY                                   *
*                           --E#Y#E--				     *
*                         ===MUSCLE===                               *
*                                                                    *
*********************************************************************/
#ifndef OPENGL_H_
#define OPENGL_H_

/* C Header Files */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <fcntl.h>
#include <unistd.h>
#include <math.h>
/* OpenGL */
#include <GL/glew.h>
#include <GL/gl.h>
#include <GL/glx.h>
#include <GL/glu.h>
/* Flysimulator */
#include "../WIN/win.h"
#include "../TEX/texture.h"
#include "../UNI/uniform.h"
#include "../OGL/cockpit.h"

/* Define */
#define ID 16
#define AV 5000

/*---------------------------------------------------------------------------*/

/* Textures Coordinate */
struct f_texture
{
	GLfloat s;
	GLfloat t;
};

/* Init Triangles */
struct f_triangles
{
	GLfloat x;
	GLfloat y;
	GLfloat z;
};

/* Structure Float */
struct f_float
{
	struct f_texture tex;
	struct f_triangles tri;
}gl;

/* OpenGL */
void loadTexture();
void loadConfig(char code, float config);
void initGrid();
void textureShader(GLuint shader);
void PlaneView(GLfloat xPlane, GLfloat yPlane, GLfloat zPlane,	
		GLfloat roll, GLfloat pitch, GLfloat yaw);
void GridRender(char *name);
void SubImage1(char *name, GLubyte *pixel);
void SubImage2(GLubyte *pixel);
void Landscape();
void process_event1(XEvent report);

/*---------------------------------------------------------------------------*/

#endif
