/*********************************************************************
*                                                                    *          
*                              FLY                                   *
*                           --E#Y#E--				     *
*                         ===MUSCLE===                               *
*                                                                    *
*********************************************************************/
#ifndef UNIFORM_H_
#define UNIFORM_H_

/* C Header Files */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <fcntl.h>
#include <unistd.h>
#include <math.h>
/* OpenGL */
#include <GL/glew.h>
#include <GL/gl.h>
#include <GL/glx.h>
#include <GL/glu.h>
/* Flysimulator */
#include "../OGL/cockpit.h"
#include "../OGL/opengl.h"

/*-------------------------------------------------------------------------*/

char *vert;
char *frag;
const GLchar* tmp;

GLuint location;
GLuint normalPosition;
GLuint colorPosition;
GLuint vertexPosition;
GLuint fudgeLocation;
GLuint projectionMatrix;
GLuint modelViewMatrix;

struct fragment
{
	char *log;
	unsigned int id;
	GLuint filename;
	GLuint source;
	GLint result;
	GLint info;
	
}fragmentShader;

struct vertex
{
	char *log;
	unsigned int id;
	GLuint filename;
	GLuint source;
	GLint result;
	GLint info;
	
}vertexShader;

/*-------------------------------------------------------------------------*/

/* Function */
void CreateShader();
void CreateProgram(GLuint shaderProgram);
void Location(GLuint shaderProgram, unsigned int index, const char* name);
void Uniform(GLuint shaderProgram, const char* name ,const float matrix);
void Uniform4x4(GLuint shaderProgram, const char* name, char transpose, const float* matrix);
void DeleteShader(GLuint shaderProgram);

/*-------------------------------------------------------------------------*/

#endif


