/*********************************************************************
*                                                                    *          
*                              FLY                                   *
*                           --E#Y#E--				     *
*                         ===MUSCLE===                               *
*                                                                    *
*********************************************************************/
#ifndef COCKPIT_H_
#define COCKPIT_H_

/* C++ Header Files */
#include <map>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <fstream>
#include <iostream>
#include <vector>
#include <cmath>
#include <sys/time.h>
/* OpenGL */
#include <GL/glew.h>
#include <GL/gl.h>
#include <GL/glx.h>
#include <GL/glu.h>
/* Flysimulator */
#include "../WIN/win.h"
#include "../TEX/texture.h"
#include "../UNI/uniform.h"
#include "../OGL/opengl.h"

/* Define */
#define ID 16
#define AV 5000

//---------------------------------------------------------------------------

/* Class MOD */
class MOD
{
private:
	/* Plane */
	GLfloat xPlane;
	GLfloat yPlane;
	GLfloat zPlane;	
	GLfloat roll; 
	GLfloat pitch;
	GLfloat yaw;
	
public:		
	/* Cockpit */
	void CameraLook();
	void Plane(GLfloat xPlane, GLfloat yPlane, GLfloat zPlane);
	void Speed(float dt);
	void Zylinder();
	void Motor();
	void Cockpit();
	void process_event2(XEvent report);
};

//---------------------------------------------------------------------------

#endif

